<?php
/**
* Thanks to Chris for the original plugin used for a previous version of
* Community Builder and Joomla 1.5. This plugin has been rewritten from 
* scratch to work with Joomla 2.5 and Community Builder 1.8.
* http://www.joomlapolis.com/forum/40-cb-newbies/57781-auto-approve-and-auto-confirm-users-with-sso#57882
*
* @author     Shaun Maunder <shaun@shmanic.com>
* @package    Joomla.Plugin
* @subpackage User.CBAutoCreate
*
* @copyright Copyright (C) 2012 Shaun Maunder. All rights reserved.
* @license   GNU General Public License version 2 or later; see LICENSE.txt
*/

defined('_JEXEC') or die;

/**
 * Community Builder auto user creation plugin.
 *
 * The plugin was created to help with CB Single Sign On.
 *
 * @package    Joomla.Plugin
 * @subpackage User.CBAutoCreate
 *
 * @since      2.5
 */
class plgUserCBAutoCreate extends JPlugin 
{

	/**
	* Utility method to act on a user after it has been saved.
	*
	* This method creates a CB user if one doesn't exist.
	*
	* @param array   $user    Holds the new user data.
	* @param boolean $isnew   True if a new user is stored.
	* @param boolean $success True if user was succesfully stored in the database.
	* @param string  $msg     Message.
	*
	* @return void
	* @since  2.5
	*/
	function onUserAfterSave($user, $isNew, $success, $msg)
	{
		$userId = (int) $user['id'];

	  $db = JFactory::getDBO();
		$query = $db->getQuery(true);

		// Check if the CB user already exists
		$query->select($query->qn('id'))
			->from($query->qn('#__comprofiler'))
			->where($query->qn('id') . ' = ' . $query->q($userId));

		$db->setQuery($query);

		if (!$db->loadResult()) {

			// Create the CB user table entry
			$query->clear();
			$query->insert($query->qn('#__comprofiler'))
				->columns(array($query->qn('id'), $query->qn('user_id')))
				->values($query->q($userId) . ', ' . $query->q($userId));

			$db->setQuery($query);
			
			$db->query();
		}
	}
}
